#include <stdio.h>
#include <stdlib.h>
#include "listacab.h"
#include "conjuntos.h"

/*Un ejercicio tpico de listas*/
/*los elementos de la lista en este caso son cadenas de caracteres*/
/*Se trata de crear el TAD Conjunto a partir del TAD Lista*/
/*Utilizando conjuntos, hay que imprimir en pantalla las palabras*/
/*comunes a dos ficheros de texto. Una posible forma de resolver el ejercicio*/
/*es la siguiente: crear dos conjuntos, cada uno representante de un fichero.*/
/*La inserseccin de estos conjuntos es la solucin del problema.*/
/*Esta solucin es la que est implementada aqu.*/

void llenar(FILE *);
/*solicita cadenas de caracteres y las aade a un fichero de texto*/
void imprime(conjunto);
/*muestra en pantalla el contenido de un conjunto, palabra a palabra*/
void de_file_a_conjunto(FILE *,conjunto);
/*incluye las palabras de un archivo en un conjunto*/

int main()
{
 FILE *f1,*f2;
 conjunto a=crearconjunto(),b=crearconjunto(),inter=crearconjunto();
 f1=fopen("f1.txt","w");
 f2=fopen("f2.txt","w");

 printf("Este ejercicio almacena en dos conjuntos las palabras de que consta un\n");
 printf("archivo de texto, crea el conjunto interseccion de los dos primeros y\n");
 printf("muestra su contenido en pantalla.\n\n");
 printf("Llenamos el fichero de texto 1.\n");
 printf("Para acabar, escribe fin y pulsa enter.\n");
 llenar(f1);
 printf("Lo mismo para el fichero 2.\n");
 llenar(f2);

 fclose(f1);
 fclose(f2);

 f1=fopen("f1.txt","r");
 f2=fopen("f2.txt","r");

 de_file_a_conjunto(f1,a);
 de_file_a_conjunto(f2,b);

 inter=interseccion(a,b);
 printf("Las palabras comunes a ambos ficheros son: ");
 imprime(inter);

 fclose(f1);
 fclose(f2);
 destruirconjunto(a);
 destruirconjunto(b);
 destruirconjunto(inter);

 system("PAUSE");
 return 0;
}


void llenar(FILE *f1)
{
 char cad[30]="",fin[4]="fin";
 while(strcmp(cad,fin))
 {
  printf("Escribe una palabra y pulsa enter: ");
  gets(cad);
  if(strcmp(cad,fin))
  {
   fputs(cad,f1);
   fputc('\n',f1);
  }
 }
}

void imprime(conjunto a)
{
 posicion p=primera(a);
 if(conjuntovacio(a))
  printf("Conjunto vacio\n");
 else
  while(p!=fin(a))
  {
   printf("%s ",recuperar(p,a));
   p=siguiente(p,a);
  }
 printf("\n");
}

void de_file_a_conjunto(FILE *f1,conjunto a)
{
 char cad[15]="";
 while(!feof(f1))
 {
  fgets(cad,15,f1);
  if(!feof(f1))
   incluir(cad,a);
 }
}
