/******************************/
/*       TAD CONJUNTO         */
/******************************/
/*un conjunto es una coleccin o lista de cosas.*/
/*En esta implementacin, se utiliza una lista para dar forma a un conjunto*/
#ifndef _CONJUNTO_
#define _CONJUNTO_

typedef lista conjunto;

/*precondicion general: los conjuntos han sido previamente creados*/
conjunto crearconjunto();
/*devuelve un conjunto vaco*/
int conjuntovacio(conjunto a);
/*postcondiciones: devuelve 1 si un conjunto vacio*/
void incluir(char x[],conjunto a);
/*postcondiciones: incluye la cadena x en el conjunto*/
conjunto union_(conjunto a,conjunto b);
/*postcondiciones: devuelve el conjunto unin*/
conjunto interseccion(conjunto a,conjunto b);
/*postcondiciones: devuelve el conjunto interseccin*/
conjunto diferencia(conjunto a,conjunto b);
/*postcondiciones: devuelve el conjunto diferencia a/b*/
void destruirconjunto(conjunto a);
#endif
