/************************************/
/*   LISTA DINAMICA CON CABECERA    */
/************************************/

#ifndef _telemento_
#define _telemento_
typedef char *telemento; /*no pongo char telemento[20] porque entonces*/
#endif                   /*recuperar tendria que devolver la cadena*/
#ifndef _listacab_       /*(segun la especificacin) y eso no se puede en c*/
#define _listacab_

        typedef struct nodo {
                char elemento[20]; /*20 es un valor cualquiera, apropiado para una palabra*/
                struct nodo *sig;
                }tiponodo;

        typedef tiponodo *lista;
        typedef tiponodo *posicion;

lista crearlista();
/*reserva memoria para una lista vacia y la devuelve*/

void insertar(telemento x,posicion p,lista l);
/*inserta el telemento x en la posicion p de la lista l*/

void eliminar(posicion p,lista l);
/*elimina el elemento que ocupa la posicion p en la lista*/

telemento recuperar(posicion p,lista l);
/*devuelve el elemento que ocupa la posicion p en la lista*/

posicion buscar(telemento x,lista l);
/*devuelve la posicion de x en la lista. Si x no est, devuelve la posicion "fin"*/

posicion siguiente(posicion p,lista l);
/*devuelve la posicion inmediatamente siguiente a la del elemento indicado por p*/

posicion anterior(posicion p,lista l);
/*devuelve una posicion inmediatamente anterior a la del elemento indicado por p*/

posicion primera(lista l);
/*devuelve la posicion del primer elemento de la lista*/

posicion fin(lista l);
/*devuelve la posicion siguiente a la del ultimo elemento*/

void destruirlista(lista l);
/*libera la memoria correspondiente a la lista*/

#endif
