#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "listacab.h"
#include "conjuntos.h"

/********funcion interna*********************/
static int pertenece(char x[],conjunto a)
{
 if(buscar(x,a)==fin(a))
  return 0;
 else
  return 1;
}

/**********funciones publicas**********************/
conjunto crearconjunto()
/*utilizo funciones ya existentes para ahorrar trabajo*/
{
 crearlista();
}

int conjuntovacio(conjunto a)
{
 return (primera(a)==fin(a));
}

void incluir(char x[],conjunto a)
{
 insertar(x,primera(a),a);
}

conjunto interseccion(conjunto a,conjunto b)
{
 conjunto res=crearlista();
 posicion p=primera(a),q=primera(b);
 while(p!=fin(a))
 {
  if(pertenece(recuperar(p,a),b)) /*si el elemento de a pertenece a b...*/
   incluir(recuperar(p,a),res);
  p=siguiente(p,a);
 }
 return res;
}

conjunto union_(conjunto a,conjunto b) /*se incluye en la solucion a A y a B, simplemente*/
{
 conjunto res=crearlista();
 posicion p=primera(a),q=primera(b);
 while(p!=fin(a))/*incluimos en res los elementos de a*/
 {
  incluir(recuperar(p,a),res);
  p=siguiente(p,a);
 }
 while(q!=fin(b))/*incluimos en res los elementos de b*/
 {
  incluir(recuperar(q,b),res);
  q=siguiente(q,b);
 }
 return res;
}

conjunto diferencia(conjunto a,conjunto b)
{
 conjunto res=crearlista();
 posicion p=primera(a),q=primera(b);
 while(p!=fin(a))
 {
  if(!pertenece(recuperar(p,a),b)) /*si el elemento actual de a NO pertenece a b...*/
   incluir(recuperar(p,a),res);
  p=siguiente(p,a);
 }
 return res;
}

void destruirconjunto(conjunto a)
{
 destruirlista(a);
}
